/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'vliw.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.vliw.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.instruction.IOperation;
import ru.ispras.microtesk.model.api.instruction.Operation;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.IAddressingMode;
import ru.ispras.microtesk.model.vliw.mode.*;

import static ru.ispras.microtesk.model.vliw.shared.Shared.*;

public final class ADD_S extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         ADD_S.class,
         "ADD_S",
         false,
         new ParamDecls()
             .declareParam("fd", ArgumentMode.OUT, F.INFO)
             .declareParam("fs", ArgumentMode.IN, F.INFO)
             .declareParam("ft", ArgumentMode.IN, F.INFO),
         false,
         false,
         false,
         false,
         false,
         0);
    }

    @Override
    public IOperation create(Map<String, Object> args) {
      final IAddressingMode fd = (IAddressingMode) getArgument("fd", args);
      final IAddressingMode fs = (IAddressingMode) getArgument("fs", args);
      final IAddressingMode ft = (IAddressingMode) getArgument("ft", args);

      return new ADD_S(fd, fs, ft);
    }
  }

  public static final IInfo INFO = new Info();

  private final IAddressingMode fd;
  private final IAddressingMode fs;
  private final IAddressingMode ft;

  public ADD_S(IAddressingMode fd, IAddressingMode fs, IAddressingMode ft) {
    assert F.INFO.isSupported(fd);
    assert F.INFO.isSupported(fs);
    assert F.INFO.isSupported(ft);

    this.fd = fd;
    this.fs = fs;
    this.ft = ft;
  }

  @Override
  public String syntax() {
    return String.format("ADD_S %s, %s, %s", fd.syntax(), fs.syntax(), ft.syntax());
  }

  @Override
  public String image() {
    return String.format("01000110000%s%s%s000000", ft.image(), fs.image(), fd.image());
  }

  @Override
  public void action() {
    fd.access().store(DataEngine.execute(EOperatorID.PLUS, fs.access().load(), ft.access().load()));
  }
}
